Bullet Collision Detection & Physics Library: btReducedDeformableRigidContactConstraint Class Reference

Bullet Collision Detection & Physics Library

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | List of all members
btReducedDeformableRigidContactConstraint Class Referenceabstract

`#include <btReducedDeformableContactConstraint.h>`

Inheritance diagram for btReducedDeformableRigidContactConstraint:
[legend]
Collaboration diagram for btReducedDeformableRigidContactConstraint:
[legend]

## Public Member Functions
| btReducedDeformableRigidContactConstraint (btReducedDeformableBody *rsb, const btSoftBody::DeformableRigidContact &c, const btContactSolverInfo &infoGlobal, btScalar dt)
| btReducedDeformableRigidContactConstraint ()
virtual | ~btReducedDeformableRigidContactConstraint ()
void | setSolverBody (const int bodyId, btSolverBody &solver_body)
virtual void | warmStarting ()
virtual btScalar | solveConstraint (const btContactSolverInfo &infoGlobal)
void | calculateTangentialImpulse (btScalar &deltaImpulse_tangent, btScalar &appliedImpulse, const btScalar rhs_tangent, const btScalar tangentImpulseFactorInv, const btVector3 &tangent, const btScalar lower_limit, const btScalar upper_limit, const btVector3 &deltaV_rel)
virtual void | applyImpulse (const btVector3 &impulse)
virtual void | applySplitImpulse (const btVector3 &impulse)
virtual btVector3 | getVa () const
virtual btVector3 | getDeltaVa () const =0
virtual btVector3 | getDeltaVb () const =0
Public Member Functions inherited from btDeformableRigidContactConstraint
| btDeformableRigidContactConstraint (const btSoftBody::DeformableRigidContact &c, const btContactSolverInfo &infoGlobal)
| btDeformableRigidContactConstraint (const btDeformableRigidContactConstraint &other)
| btDeformableRigidContactConstraint ()
virtual | ~btDeformableRigidContactConstraint ()
virtual btVector3 | getVa () const
virtual btVector3 | getSplitVb () const =0
virtual btVector3 | getSplitVa () const
virtual btScalar | solveConstraint (const btContactSolverInfo &infoGlobal)
virtual void | setPenetrationScale (btScalar scale)
btScalar | solveSplitImpulse (const btContactSolverInfo &infoGlobal)
virtual void | applySplitImpulse (const btVector3 &impulse)=0
Public Member Functions inherited from btDeformableContactConstraint
| btDeformableContactConstraint (const btVector3 &normal, const btContactSolverInfo &infoGlobal)
| btDeformableContactConstraint (bool isStatic, const btVector3 &normal, const btContactSolverInfo &infoGlobal)
| btDeformableContactConstraint ()
| btDeformableContactConstraint (const btDeformableContactConstraint &other)
virtual | ~btDeformableContactConstraint ()
virtual btScalar | solveConstraint (const btContactSolverInfo &infoGlobal)=0
virtual btVector3 | getVa () const =0
virtual btVector3 | getVb () const =0
virtual btVector3 | getDv (const btSoftBody::Node *) const =0
virtual void | applyImpulse (const btVector3 &impulse)=0
virtual void | setPenetrationScale (btScalar scale)=0

## Public Attributes
bool | m_collideStatic
bool | m_collideMultibody
int | m_nodeQueryIndex
int | m_solverBodyId
btReducedDeformableBody * | m_rsb
btSolverBody * | m_solverBody
btScalar | m_dt
btScalar | m_appliedNormalImpulse
btScalar | m_appliedTangentImpulse
btScalar | m_appliedTangentImpulse2
btScalar | m_normalImpulseFactor
btScalar | m_tangentImpulseFactor
btScalar | m_tangentImpulseFactor2
btScalar | m_tangentImpulseFactorInv
btScalar | m_tangentImpulseFactorInv2
btScalar | m_rhs
btScalar | m_rhs_tangent
btScalar | m_rhs_tangent2
btScalar | m_cfm
btScalar | m_cfm_friction
btScalar | m_erp
btScalar | m_erp_friction
btScalar | m_friction
btVector3 | m_contactNormalA
btVector3 | m_contactNormalB
btVector3 | m_contactTangent
btVector3 | m_contactTangent2
btVector3 | m_relPosA
btVector3 | m_relPosB
btMatrix3x3 | m_impulseFactor
btVector3 | m_bufferVelocityA
btVector3 | m_bufferVelocityB
btVector3 | m_linearComponentNormal
btVector3 | m_angularComponentNormal
btVector3 | m_linearComponentTangent
btVector3 | m_angularComponentTangent
Public Attributes inherited from btDeformableRigidContactConstraint
btVector3 | m_total_normal_dv
btVector3 | m_total_tangent_dv
btScalar | m_penetration
btScalar | m_total_split_impulse
bool | m_binding
const btSoftBody::DeformableRigidContact * | m_contact
Public Attributes inherited from btDeformableContactConstraint
bool | m_static
const btContactSolverInfo * | m_infoGlobal
btVector3 | m_normal

## Detailed Description

Definition at line 41 of file btReducedDeformableContactConstraint.h.

## Constructor & Destructor Documentation

## ◆ btReducedDeformableRigidContactConstraint() [1/2]

btReducedDeformableRigidContactConstraint::btReducedDeformableRigidContactConstraint | ( | btReducedDeformableBody * | rsb,
|  | const btSoftBody::DeformableRigidContact & | c,
|  | const btContactSolverInfo & | infoGlobal,
|  | btScalar | dt
| ) |  |

Definition at line 59 of file btReducedDeformableContactConstraint.cpp.

## ◆ btReducedDeformableRigidContactConstraint() [2/2]

btReducedDeformableRigidContactConstraint::btReducedDeformableRigidContactConstraint | ( |  | ) |
| inline

Definition at line 93 of file btReducedDeformableContactConstraint.h.

## ◆ ~btReducedDeformableRigidContactConstraint()

virtual btReducedDeformableRigidContactConstraint::~btReducedDeformableRigidContactConstraint | ( |  | ) |
| inlinevirtual

Definition at line 94 of file btReducedDeformableContactConstraint.h.

## Member Function Documentation

## ◆ applyImpulse()

virtual void btReducedDeformableRigidContactConstraint::applyImpulse | ( | const btVector3 & | impulse | ) |
| inlinevirtual

Implements btDeformableContactConstraint.

Reimplemented in btReducedDeformableNodeRigidContactConstraint, and btReducedDeformableFaceRigidContactConstraint.

Definition at line 111 of file btReducedDeformableContactConstraint.h.

## ◆ applySplitImpulse()

virtual void btReducedDeformableRigidContactConstraint::applySplitImpulse | ( | const btVector3 & | impulse | ) |
| inlinevirtual

Implements btDeformableRigidContactConstraint.

Definition at line 113 of file btReducedDeformableContactConstraint.h.

## ◆ calculateTangentialImpulse()

void btReducedDeformableRigidContactConstraint::calculateTangentialImpulse | ( | btScalar & | deltaImpulse_tangent,
|  | btScalar & | appliedImpulse,
|  | const btScalar | rhs_tangent,
|  | const btScalar | tangentImpulseFactorInv,
|  | const btVector3 & | tangent,
|  | const btScalar | lower_limit,
|  | const btScalar | upper_limit,
|  | const btVector3 & | deltaV_rel
| ) |  |

Definition at line 290 of file btReducedDeformableContactConstraint.cpp.

## ◆ getDeltaVa()

virtual btVector3 btReducedDeformableRigidContactConstraint::getDeltaVa | ( |  | ) | const
| pure virtual

Implemented in btReducedDeformableNodeRigidContactConstraint.

## ◆ getDeltaVb()

virtual btVector3 btReducedDeformableRigidContactConstraint::getDeltaVb | ( |  | ) | const
| pure virtual

Implemented in btReducedDeformableNodeRigidContactConstraint.

## ◆ getVa()

btVector3 btReducedDeformableRigidContactConstraint::getVa | ( |  | ) | const
| virtual

Reimplemented from btDeformableRigidContactConstraint.

Definition at line 97 of file btReducedDeformableContactConstraint.cpp.

## ◆ setSolverBody()

void btReducedDeformableRigidContactConstraint::setSolverBody | ( | const int | bodyId,
|  | btSolverBody & | solver_body
| ) |  |

Definition at line 81 of file btReducedDeformableContactConstraint.cpp.

## ◆ solveConstraint()

btScalar btReducedDeformableRigidContactConstraint::solveConstraint | ( | const btContactSolverInfo & | infoGlobal | ) |
| virtual

Reimplemented from btDeformableRigidContactConstraint.

Definition at line 107 of file btReducedDeformableContactConstraint.cpp.

## ◆ warmStarting()

virtual void btReducedDeformableRigidContactConstraint::warmStarting | ( |  | ) |
| inlinevirtual

Reimplemented in btReducedDeformableNodeRigidContactConstraint.

Definition at line 98 of file btReducedDeformableContactConstraint.h.

## Member Data Documentation

## ◆ m_angularComponentNormal

btVector3 btReducedDeformableRigidContactConstraint::m_angularComponentNormal

Definition at line 83 of file btReducedDeformableContactConstraint.h.

## ◆ m_angularComponentTangent

btVector3 btReducedDeformableRigidContactConstraint::m_angularComponentTangent

Definition at line 86 of file btReducedDeformableContactConstraint.h.

## ◆ m_appliedNormalImpulse

btScalar btReducedDeformableRigidContactConstraint::m_appliedNormalImpulse

Definition at line 54 of file btReducedDeformableContactConstraint.h.

## ◆ m_appliedTangentImpulse

btScalar btReducedDeformableRigidContactConstraint::m_appliedTangentImpulse

Definition at line 55 of file btReducedDeformableContactConstraint.h.

## ◆ m_appliedTangentImpulse2

btScalar btReducedDeformableRigidContactConstraint::m_appliedTangentImpulse2

Definition at line 56 of file btReducedDeformableContactConstraint.h.

## ◆ m_bufferVelocityA

btVector3 btReducedDeformableRigidContactConstraint::m_bufferVelocityA

Definition at line 80 of file btReducedDeformableContactConstraint.h.

## ◆ m_bufferVelocityB

btVector3 btReducedDeformableRigidContactConstraint::m_bufferVelocityB

Definition at line 81 of file btReducedDeformableContactConstraint.h.

## ◆ m_cfm

btScalar btReducedDeformableRigidContactConstraint::m_cfm

Definition at line 66 of file btReducedDeformableContactConstraint.h.

## ◆ m_cfm_friction

btScalar btReducedDeformableRigidContactConstraint::m_cfm_friction

Definition at line 67 of file btReducedDeformableContactConstraint.h.

## ◆ m_collideMultibody

bool btReducedDeformableRigidContactConstraint::m_collideMultibody

Definition at line 45 of file btReducedDeformableContactConstraint.h.

## ◆ m_collideStatic

bool btReducedDeformableRigidContactConstraint::m_collideStatic

Definition at line 44 of file btReducedDeformableContactConstraint.h.

## ◆ m_contactNormalA

btVector3 btReducedDeformableRigidContactConstraint::m_contactNormalA

Definition at line 72 of file btReducedDeformableContactConstraint.h.

## ◆ m_contactNormalB

btVector3 btReducedDeformableRigidContactConstraint::m_contactNormalB

Definition at line 73 of file btReducedDeformableContactConstraint.h.

## ◆ m_contactTangent

btVector3 btReducedDeformableRigidContactConstraint::m_contactTangent

Definition at line 74 of file btReducedDeformableContactConstraint.h.

## ◆ m_contactTangent2

btVector3 btReducedDeformableRigidContactConstraint::m_contactTangent2

Definition at line 75 of file btReducedDeformableContactConstraint.h.

## ◆ m_dt

btScalar btReducedDeformableRigidContactConstraint::m_dt

Definition at line 52 of file btReducedDeformableContactConstraint.h.

## ◆ m_erp

btScalar btReducedDeformableRigidContactConstraint::m_erp

Definition at line 68 of file btReducedDeformableContactConstraint.h.

## ◆ m_erp_friction

btScalar btReducedDeformableRigidContactConstraint::m_erp_friction

Definition at line 69 of file btReducedDeformableContactConstraint.h.

## ◆ m_friction

btScalar btReducedDeformableRigidContactConstraint::m_friction

Definition at line 70 of file btReducedDeformableContactConstraint.h.

## ◆ m_impulseFactor

btMatrix3x3 btReducedDeformableRigidContactConstraint::m_impulseFactor

Definition at line 78 of file btReducedDeformableContactConstraint.h.

## ◆ m_linearComponentNormal

btVector3 btReducedDeformableRigidContactConstraint::m_linearComponentNormal

Definition at line 82 of file btReducedDeformableContactConstraint.h.

## ◆ m_linearComponentTangent

btVector3 btReducedDeformableRigidContactConstraint::m_linearComponentTangent

Definition at line 85 of file btReducedDeformableContactConstraint.h.

## ◆ m_nodeQueryIndex

int btReducedDeformableRigidContactConstraint::m_nodeQueryIndex

Definition at line 47 of file btReducedDeformableContactConstraint.h.

## ◆ m_normalImpulseFactor

btScalar btReducedDeformableRigidContactConstraint::m_normalImpulseFactor

Definition at line 57 of file btReducedDeformableContactConstraint.h.

## ◆ m_relPosA

btVector3 btReducedDeformableRigidContactConstraint::m_relPosA

Definition at line 76 of file btReducedDeformableContactConstraint.h.

## ◆ m_relPosB

btVector3 btReducedDeformableRigidContactConstraint::m_relPosB

Definition at line 77 of file btReducedDeformableContactConstraint.h.

## ◆ m_rhs

btScalar btReducedDeformableRigidContactConstraint::m_rhs

Definition at line 62 of file btReducedDeformableContactConstraint.h.

## ◆ m_rhs_tangent

btScalar btReducedDeformableRigidContactConstraint::m_rhs_tangent

Definition at line 63 of file btReducedDeformableContactConstraint.h.

## ◆ m_rhs_tangent2

btScalar btReducedDeformableRigidContactConstraint::m_rhs_tangent2

Definition at line 64 of file btReducedDeformableContactConstraint.h.

## ◆ m_rsb

btReducedDeformableBody* btReducedDeformableRigidContactConstraint::m_rsb

Definition at line 50 of file btReducedDeformableContactConstraint.h.

## ◆ m_solverBody

btSolverBody* btReducedDeformableRigidContactConstraint::m_solverBody

Definition at line 51 of file btReducedDeformableContactConstraint.h.

## ◆ m_solverBodyId

int btReducedDeformableRigidContactConstraint::m_solverBodyId

Definition at line 48 of file btReducedDeformableContactConstraint.h.

## ◆ m_tangentImpulseFactor

btScalar btReducedDeformableRigidContactConstraint::m_tangentImpulseFactor

Definition at line 58 of file btReducedDeformableContactConstraint.h.

## ◆ m_tangentImpulseFactor2

btScalar btReducedDeformableRigidContactConstraint::m_tangentImpulseFactor2

Definition at line 59 of file btReducedDeformableContactConstraint.h.

## ◆ m_tangentImpulseFactorInv

btScalar btReducedDeformableRigidContactConstraint::m_tangentImpulseFactorInv

Definition at line 60 of file btReducedDeformableContactConstraint.h.

## ◆ m_tangentImpulseFactorInv2

btScalar btReducedDeformableRigidContactConstraint::m_tangentImpulseFactorInv2

Definition at line 61 of file btReducedDeformableContactConstraint.h.

The documentation for this class was generated from the following files:

- btReducedDeformableContactConstraint.h
- btReducedDeformableContactConstraint.cpp